<?php

namespace App\Http\Requests;

use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

class PatientRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        $role = [Null];
        if (! Auth::check()) {
            return false;
        }
        if(in_array(Auth::user()->role_id, $role))
        {
            return false;
        }
        if(Auth::user()->hasModule('users'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules=[
            'name'=>'required',
            'date_of_birth'=>'required',
            'status'=>'required',
            'gender'=>'required',
            'job'=>'required',
            'knowledge'=>'required',
            'branches'=>'required',
             'email' => [
                'required',
               
            ],
            'phone'=> [
                "required",
                "numeric",
                "digits_between:11,14"
            ],
            ];
 
       

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        $attributes=[
            'name'=>__('patients.name'),
            'date_of_birth'=>__('patients.date_of_birth'),
            'image'=>__('patients.image'),
            'job'=>__('tranners.job'),
            'gender'=>__('tranners.gender'),
            'status'=>__('patients.status'),
            'knowledge'=>__('patients.knowledge'),
            'phone'=>__('patients.phone'),
            'email'=>__('patients.email'),
            'branches'=>__('patients.branches'),
            ];
        
        return $attributes;
    }
    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
